<?php
/* DaumBloggerNews plugin for Textcube 1.7.X
   ----------------------------------
   Version 9.7.2
   Tatter and Media Dev team.

   Creator          : park jae-sun, yupmin
   Maintainer       : yupmin, 도아

   Created at       : 2007.
   Last modified at : 2008.11.11
 
 General Public License
 http://www.gnu.org/licenses/gpl.html

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
*/
if(!function_exists("parseDate")) {
	function parseDate($str) {
		if(preg_match('/^(\d{4})년 (\d{2})월 (\d{2})일  (\d{2}):(\d{2}):(\d{2})$/', $str, $matches))
			return parseDate("{$matches[1]}-{$matches[2]}-{$matches[3]} {$matches[4]}:{$matches[5]}:{$matches[6]}");
		if(preg_match('/^(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})$/', $str, $matches))
			return parseDate("{$matches[3]}-{$matches[1]}-{$matches[2]} {$matches[4]}:{$matches[5]}:00}");
		if (empty($str))
			return 0;
		$time = strtotime($str);
		if($time !== -1)
			return $time;
		$gmt = (substr($str, strpos($str, "GMT")) == "GMT") ? 9 : 0;
		$str = str_replace("년 ", "-", $str);
		$str = str_replace("월 ", "-", $str);
		$str = str_replace("일 ", "", $str);
		$str = str_replace("GMT", "", $str);
		$str = str_replace("KST", "+0900", $str);
		if (strpos($str, "T")) {
			list($date, $time) = explode("T", $str);
			list($y, $m, $d) = explode("-", $date);
			list($time) = explode("+", $time);
			@list($h, $i, $s) = explode(":", $time);
		} else if (strpos($str, ":") && strpos($str, "-")) {
			list($str) = explode(".", $str);
			list($date, $time) = explode(" ", $str);
			list($y, $m, $d) = explode("-", $date);
			if ($d > 1900) {
				$t = $y;
				$y = $d;
				$d = $m;
				$m = $t;
			}
			@list($h, $i, $s) = explode(":", $time);
		} else if (strpos($str, ",") && strpos($str, ":")) {
			list($temp, $str) = explode(",", $str);
			$str = trim(str_month_check($str));
			list($d, $m, $y, $time) = explode(" ", $str);
			list($h, $i, $s) = explode(":", $time);
		} else {
			return gmmktime();
		}
		if (!$h)
			$h = "00";
		if (!$i)
			$i = "00";
		if (!$s)
			$s = "00";
		$h += $gmt;

		return mktime($h, $i, $s, $m, $d, $y);
	}
}

// models
function DBN_get_category_select($entryId) {
	global $database, $blogid;
	if( !Validator::id($entryId) ) return false;
	$data = POD::queryRow("SELECT * FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid AND entryid = $entryId");
	return $data;
}

function DBN_set_category_select($categoryId, $channel, $entryId) {
	global $database, $blogid, $user;
	$userid = $user['id'];
	if( !Validator::id($userid) ) return false;

	// 새로, 임시 작성된 글에 카테고리 정하기(entryId이 0일때)
	if( empty($entryId) ) {
		return POD::query("REPLACE INTO {$database['prefix']}DaumBloggerNews(blogid, entryid, userid, categoryid, channel, send) VALUES ($blogid, 0 , $userid , '$categoryId', '$channel', 0)");
	}
	$data = DBN_get_category_select($entryId);
	// 트랙백을 보내지 않을때
	if (!is_null($data) && $data['send'] == 0 ) {
		return POD::query("UPDATE {$database['prefix']}DaumBloggerNews SET categoryid = '$categoryId', channel = '$channel' where blogid = $blogid AND entryid = $entryId ");
	// ok인 상태
	} else if( !is_null($data) && $data['send'] > 0  ) {
		return true;
	// 정보조차 없을때 
	} else {
		return POD::query("INSERT INTO {$database['prefix']}DaumBloggerNews(blogid, entryid, userid, categoryid, channel, send) VALUES ($blogid, $entryId , $userid, '$categoryId', '$channel', 0)");
	}
	return false;
}

function DBN_clear_category_select() {
	global $database, $blogid, $user;
	$userid = $user['id'];
	if( !Validator::id($target) || !Validator::id($userid) ) return false;
	return POD::query("DELETE FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid AND userid = $userid AND entryid = 0 ");
}

function DBN_reset_category_select(){
	global $database, $blogid;
	if( POD::queryExistence("SELECT * FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid") )
		POD::query("DELETE FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid");
}

function DBN_sync_selection_info($target){
	global $database, $blogid, $user;
	$userid = $user['id'];
	if( !Validator::id($target) || !Validator::id($userid) ) return false;
	return POD::query("UPDATE {$database['prefix']}DaumBloggerNews SET entryid = $target WHERE blogid = $blogid AND userid = $userid AND entryid = 0");
}

function DBN_send_trackback($entryId){
	global $database, $defaultURL, $blogid;

	if(!Validator::id($entryId) ) return false;
	$selectionInfo = DBN_get_category_select($entryId);
	if( is_null($selectionInfo) || empty($selectionInfo['categoryid']) ) return false;
	$channel = $selectionInfo['channel'];

	requireModel('blog.trackback');
	$tb_result = sendTrackback($blogid, $entryId, "http://bloggernews.media.daum.net/tb/ch/$channel");
	$dbn_result = POD::query("UPDATE {$database['prefix']}DaumBloggerNews SET send = UNIX_TIMESTAMP() WHERE blogid = $blogid AND entryid = $entryId");

	return ($tb_result && $dbn_result); 
}

function DBN_get_permalink($blogid, $entryId) {
	global $database, $blogURL, $blog;
	$row = POD::queryRow("SELECT category, slogan FROM {$database['prefix']}Entries WHERE blogid = $blogid AND id = $entryId");
	if (is_null($row)) return false;
	if ($row['category'] == -2) return "$blogURL/notice/{$entryId}";
	if ($row['category'] < 0) return false;
	
	return "$blogURL/".($blog['useSlogan'] ? "entry/" . encodeURL($row['slogan']) : $entryId);
}

function DBN_delete_bloggernews($entryId) {
	global $database, $blogid;
	if( !Validator::id($entryId) ) return false;

	return POD::query("DELETE FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid AND entryid = $entryId");
}

function DBN_get_bloggernews_id($entryId){
	global $database, $blogid;

	if(!Validator::id($entryId))
		return null;

	$blognewsid = POD::queryCell("SELECT blognewsid FROM {$database['prefix']}DaumBloggerNews WHERE entryid = $entryId AND blogid = $blogid limit 1");

	if(is_null($blognewsid) || empty($blognewsid)) {
		$blognewsid = DBN_get_bloggernews_id_by_permalink($entryId);
		if( $blognewsid == false) $blognewsid = null;
	}
	return $blognewsid;
}

/* DBN_check_bloggernews_by_entry_id
   entry_id로 각 포스트가 유효한지 확인한다.
*/
function DBN_check_bloggernews_by_entry_id($entryId) {
	global $service, $database, $defaultURL, $blogid, $user;

	$blognews_id = POD::queryCell("SELECT blognewsid FROM {$database['prefix']}DaumBloggerNews WHERE entryid = $entryId AND blogid = $blogid limit 1");
	if($blognews_id) return false;

	requireComponent("Eolin.PHP.HTTPRequest");
	$apiURL = "http://bloggernews.media.daum.net/openapi/news_info.xml";
	$params = "id=".rawurlencode($blognews_id);
	$request = new HTTPRequest('GET', $apiURL);
	$request->contentType = 'application/x-www-form-urlencoded; charset=utf-8';
	$request->timeout = 1;
	$request->referer = !isset($_SERVER['HTTP_REFERER'])? '' : $_SERVER['HTTP_REFERER'];

	if($request->send($params)) {
		$xml = $request->responseText;
		$xmls = new XMLStruct();
		$xmls->open($xml, 'EUC-KR');
		$field = $xmls->selectNodes('/result/code');
		$code = $field[0]['.value'];

		return $code == "P0";
	}
	return false;
}

/* DBN_get_bloggernews_id_by_permalink
   퍼머링크로 다음블로그뉴스 id 및 업데이트 날짜를 업데이트를 한다 그리고 다음블로그뉴스 id를 반환한다.
*/
function DBN_get_bloggernews_id_by_permalink($entryId, $permaLink=false){
	global $service, $database, $defaultURL, $blogid, $user ;

	$permalink = (!$permaLink) ? "$defaultURL/$entryId" : DBN_get_permalink($blogid, $entryId);

	requireComponent("Eolin.PHP.HTTPRequest");	
	$apiURL = "http://bloggernews.media.daum.net/openapi/news_info_by_perm_link";
	$params = "permlink=".rawurlencode($permalink)."&blog_url=".rawurlencode($defaultURL);
	$request = new HTTPRequest('GET', $apiURL.'?'.$params);
	$request->contentType = 'application/x-www-form-urlencoded; charset=utf-8';
	$request->timeout = 1;
	$request->referer = !isset($_SERVER['HTTP_REFERER'])? '' : $_SERVER['HTTP_REFERER'];

	if($request->send()) {
		$xml = $request->responseText;
		$xmls = new XMLStruct();
		$xmls->open($xml, 'EUC-KR');
		$field = $xmls->selectNodes('/result/code');
		$code = $field[0]['.value'];
		if($code == "P0") {
			$field = $xmls->selectNodes('/result/entity/news');
			$id = $field[0]['id'][0]['.value'];
			$category_id = $field[0]['category_id'][0]['.value'];
			$reg_date = parseDate($field[0]["reg_date"][0]['.value']);
			if( Validator::id($id) && Validator::isInteger($reg_date) && !empty($category_id)){
				if(!POD::queryExistence("SELECT * FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid AND entryId = $entryId ")) {
					$userid = POD::queryCell("SELECT userid FROM {$database['prefix']}Entries WHERE blogid = $blogid AND id = $entryId ");
					POD::query("INSERT INTO {$database['prefix']}DaumBloggerNews(blogid, userid, entryid, send) VALUES($blogid, $userid, $entryId, $reg_date)");
				}

				$category = DBN_get_category_info($category_id);
				POD::query("UPDATE {$database['prefix']}DaumBloggerNews SET blognewsid = $id, blognewsid_checked = UNIX_TIMESTAMP(), categoryid = '$category_id'".(isset($category['channel'])?", channel = '".$category['channel']."'":'')." WHERE blogid = $blogid AND entryId = $entryId ");

				return $id;
			}
		}
	}
	return false;
}

/* DBN_get_channels
   다음블로그뉴스 채널을 가지고 와서 캐쉬화 한다.
*/
function DBN_get_bloggernews_channels_xml() {
	requireComponent('Needlworks.Cache.PageCache');
	$cache = new PageCache;
	$cache->name = 'DBN_Category_XML';
	if($cache->load()) { //If successful loads
		if((time() - $cache->dbContents) < 3600 * 24)	// refresh time check
			return $cache->contents;
	}

	requireComponent("Eolin.PHP.HTTPRequest");	
	$request = new HTTPRequest('http://api.bloggernews.media.daum.net/open/category.xml');
	$request->timeout = 1;
	$request->referer = !isset($_SERVER['HTTP_REFERER'])? '' : $_SERVER['HTTP_REFERER'];
	$xml = $request->send()? $request->responseText : null;

	$cache->contents = $xml;
	$cache->dbContents = Timestamp::getUNIXtime();
	$cache->update();
	unset($cache);

	return $xml;
}
/* DBN_get_categories
   다음블로그뉴스 채널에서 필요한것만..
*/
function DBN_get_categories() {
	$xml = DBN_get_bloggernews_channels_xml();

	$xmls = new XMLStruct();
	if (!$xmls->open($xml, 'EUC-KR'))
		return false;

	if ($xmls->getValue('/result/head/code') != "200")
		return false;

	$result = array();
	$one_depth_categories = $xmls->selectNodes('/result/entity/category');
	foreach($one_depth_categories as $one_depth_category) {
		foreach($one_depth_category['list'][0]['category'] as $two_depth_category) {
			$id = $two_depth_category['id'][0]['.value'];
			$url = $two_depth_category['url'][0]['.value'];
			$channel = $two_depth_category['category_name'][0]['.value'];
			$result[$id] = array('channel' => $channel);
		}
	}
	return $result;
}

function DBN_get_category_info($category_id) {
	$category = DBN_get_categories();
	if(empty($category)) return false;
	return $category[$category_id];
}

// view
function DBN_sidebar_view($url, $popup, $length) {
	global $service, $owner, $configVal;

	$ret = '';

	requireComponent("Eolin.PHP.HTTPRequest");	
	$request = new HTTPRequest($url);
	$request->timeout = 1;
	$request->referer = !isset($_SERVER['HTTP_REFERER'])? '' : $_SERVER['HTTP_REFERER'];
	$xml = $request->send()? $request->responseText : null;

	if (!is_null($xml)) {
		$xmls = new XMLStruct();
		if ($xmls->open($xml, 'EUC-KR')) {
			$result_code = $xmls->getValue('/result/code');
			if ($result_code == 'P0') {
				$news = $xmls->selectNodes('/result/entity/news');
				if(!is_array($news) ) return $ret;
				foreach ($xmls->selectNodes('/result/entity/news') as $field) {
					$title = $field['title'][0]['.value'];
					$link = $field['link'][0]['.value'];
					$blink = $field['blink'][0]['.value'];
					$regdate = $field['reg_date'][0]['.value'];
					if ($popup) {
						$ret = $ret."<li><a href=\"$blink\" onclick=\"window.open(this.href);return false;\" title=\"{$title}\">".UTF8::lessen($title,  $length)."</a></li>\r\n";
					} else {
						requireComponent('Textcube.Function.misc');
						$cfg = misc::fetchConfigVal($configVal);
						$cfg['myLink'] = !isset ($cfg['myLink']) ? 'link' : $cfg['myLink'];

						$linkStr = "href =\"$link\" ";
						if(strcmp($cfg['myLink'],'blink') == 0 ){
							$linkStr = " href=\"$blink\" onclick=\"window.open(this.href);return false;\" ";
						}
						$ret = $ret."<li><a $linkStr title=\"{$title}\">".UTF8::lessen($title, $length)."</a></li>\r\n";
					}
				}
			}
		}
	}
	return $ret;
}

// interface
function DaumBloggerNews_HandleSetCategory() {
	$categoryId = $_REQUEST['categoryId'];
	$channel = $_REQUEST['channel'];
	$entryId = $_REQUEST['entryId'];
	if(DBN_set_category_select($categoryId, $channel, $entryId))
		echo($category);
	else
		echo ('-1');
	return ;
}

function DaumBloggerNews_OnConfigChanged($data){
	global $database;

	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($data);

	// -----------------------------
	// ver 1.6 이하 일때
	// 일정기간 업데이트 후 삭제
	$update_map1 = array( 1 => '01003', 2 => '01004', 3 => '03008', 4 => '01005', 5 => '05006', 6 => '04001', 7 => '03001', 8 => '03004', 9 => '02001', 10 => '02007', 11 => '02003', 12 => '02007', 13 => '99999', 14 => '07001', 15 => '07002', 16 => '07003', 17 => '07004', 18 => '07005', 19 => '07006', 20 => '01003', 21 => '02001', 22 => '02001', 24 => '03002', 25 => '02004', 26 => '03005', 27 => '04004', 28 => '03007', 99 => '01003', 100 => '07007', 102 => '07009', 103 => '07008', 104 => '07010', 105 => '07015', 106 => '07011', 107 => '07014', 108 => '07013', 109 => '07012', 110 => '07016', 111 => '07017');
	$update_map2 = array( 1001 => 'spot', 1002 => 'politics', 1003 => 'society', 1004 => 'economy', 1005 => 'world', 1006 => 'media', 2001 => 'lifestory', 2002 => 'hobby', 2003 => 'food', 2004 => 'health', 2005 => 'school', 2006 => 'job', 2007 => 'travel', 2008 => 'fashion', 2009 => 'love', 2010 => 'childcare', 2011 => 'pet', 2012 => 'humor', 3001 => 'tv', 3002 => 'movie', 3003 => 'music', 3004 => 'book', 3005 => 'ani', 3006 => 'theater', 3007 => 'series', 3008 => 'culture', 3009 => 'photo', 4001 => 'it', 4002 => 'science', 4003 => 'game', 4004 => 'car', 4005 => 'blog', 4006 => 'earlyadopter', 5001 => 'soccer', 5002 => 'worldsoccer', 5003 => 'baseball', 5004 => 'worldbaseball', 5005 => 'basketball', 5006 => 'sportsgeneral', 7001 => '06worldcup', 7002 => '531', 7003 => 'yreporter', 7004 => 'survey', 7005 => 'unireporter', 7006 => '07election', 7007 => 'thank', 7008 => '08election', 7009 => 'climatechange', 7010 => 'iloveolympic', 7011 => 'beijing2008', 7012 => 'traveljeju', 7013 => 'ilovekorea', 7014 => 'itfuture', 7015 => 'nim2008', 7016 => 'cjmovie', 7017 => 'internetfuture', 7018 => 'truck');

	if (POD::queryExistence("DESC {$database['prefix']}DaumBloggerNews updated")) {	
		@POD::execute("ALTER TABLE {$database['prefix']}DaumBloggerNews DROP updated");
	}

	if (POD::queryExistence("DESC {$database['prefix']}DaumBloggerNews category")) {	
		@POD::execute("ALTER TABLE {$database['prefix']}DaumBloggerNews ADD categoryid varchar(64) NOT NULL DEFAULT '' ");
		@POD::execute("ALTER TABLE {$database['prefix']}DaumBloggerNews ADD channel varchar(64) NOT NULL DEFAULT '' ");

		$newses = POD::queryAll("SELECT blognewsid, category FROM {$database['prefix']}DaumBloggerNews WHERE blogid = $blogid ");
		foreach ($newses as $news) {
			if (isset($news['category']) && !empty($news['category'])) {
				if (isset($update_map1[$news['category']]) && isset($update_map2[$update_map1[$news['category']]])) {
					@POD::execute("UPDATE {$database['prefix']}DaumBloggerNews SET category_id ='" . $update_map1[$news['category']] . "', channel = '" . $update_map2[$update_map1[$news['category']]] . " WHERE blognewsid ='" . $news['blognewsid'] . "'");
				}
			}
		}
		@POD::execute("ALTER TABLE {$database['prefix']}DaumBloggerNews DROP category");
	}
	// -----------------------------

	requireComponent('Needlworks.Cache.PageCache');
	$cache = new PageCache;
	$cache->name = 'DBN_BestNews';
	$cache->purge();
	$cache->name = 'DBN_MyNews';
	$cache->purge();
	return true;
}

function DaumBloggerNews_OnAddPostEditorToolbox($target, $mother) {
	global $pluginURL, $service, $owner, $entry, $defaultURL, $database, $blogURL, $blogid;;

	$entryId = $entry['id'];
	$selectionInfo = array('category' => 0,'send'=> 0, 'categoryid'=> 0);
	if( $entryId == 0 ){
		// 임시로 작성한 글 같은 경우 카테고리 삭제
		DBN_clear_category_select();
	}else{
		// 공개 상태에서 다음블로그 뉴스 정보가 없으면 뉴스 정보 삭제
		if(!DBN_get_bloggernews_id_by_permalink($entryId) 
			&& POD::queryCell("SELECT visibility FROM {$database['prefix']}Entries WHERE blogid = $blogid AND id = $entryId ") >= 2)
			DBN_delete_bloggernews($entryId);

		$tmp = DBN_get_category_select($entryId);
		$selectionInfo = is_null($tmp)?$selectionInfo:$tmp;
	}

	$xml = DBN_get_bloggernews_channels_xml();
	$xmls = new XMLStruct();
	if ($xmls->open($xml, 'EUC-KR')) {
		ob_start();
		if ($xmls->getValue('/result/head/code') == "200") { 
?>
	<script type="text/javascript">
	//<![CDATA[
	function setCategory(v) {
		try{
			var values = v.split('|');
			if (values[1].length != 0) {
				var oHttp = createHttp();
				oHttp.open("GET", "<?php echo $blogURL;?>/owner/plugin/adminHandler?name=<?php echo str_replace('/plugins/', '', $pluginURL); ?>/DaumBloggerNews_HandleSetCategory&categoryId="+values[0]+"&channel="+values[1]+"&entryId="+<?php echo $entryId;?>, false);
				oHttp.send("");
			}
		} catch (e) {
			window.status = e.messge;
		}
	}

	function deleteCategory(id) {
		alert('다음 블로그 뉴스 목록에서 직접 지우세요.\n다음 블로그 뉴스 퍼머링크, 조회수와 추천수도 같이 지워집니다.');
		window.open("http://bloggernews.media.daum.net/user/my_news");
		return false;
	}
	//]]>
	</script>

	<div id='layout_bloggernews_category' style="padding:5px 0 0 10px;">
		<strong>블로거뉴스로 보내기</strong> :
		<select id='bloggernews_category' name='bloggernews_category' onchange='setCategory(this.value);' >
			<option value='0|'>선택하세요</option>
<?php
			$one_depth_categories = $xmls->selectNodes('/result/entity/category');
			foreach($one_depth_categories as $one_depth_category) {
				$one_depth_category_name = $one_depth_category['name'][0]['.value'];
				foreach($one_depth_category['list'][0]['category'] as $two_depth_category) {
					$id = $two_depth_category['id'][0]['.value'];
					$url = $two_depth_category['trackback_url'][0]['.value'];
					$two_depth_category_name = $two_depth_category['name'][0]['.value'];
					$channel = str_replace("http://bloggernews.media.daum.net/tb/ch/", '', $url);
?>
			<option value='<?php echo $id;?>|<?php echo $channel;?>' <?php echo ( ($id == $selectionInfo['categoryid'] )?'selected =\'selected\' ':'');?>><?php echo $one_depth_category_name .'-'.$two_depth_category_name;?></option>
<?php
				}
			}
?>
		</select>
<?php
		}
?>
	</div>
<?php
		$ob = ob_get_contents();
		ob_end_clean();
	}
	$target .= $ob;
	return $target;
}

function DaumBloggerNews_OnAddPost($target, $mother){
	DBN_sync_selection_info($target);
	if( $mother['visibility'] >= 2 )
		DBN_send_trackback($target);

	return $target;
}

function DaumBloggerNews_OnUpdatePost($target, $mother){
	if( $mother['visibility'] >= 2 )
		DBN_send_trackback($target);

	return $target;
}

function DaumBloggerNews_OnDeletePost($target, $mother){
	DBN_delete_bloggernews($target);

	return $target;
}

function DaumBloggerNews_OnChangeVisibility($target, $mother){
	if( $target >= 2 )
		DBN_send_trackback($mother);

	return $target;
}

function DaumBloggerNews_RecommandWiget($target, $mother){
	global $configVal, $entryView, $blogURL, $hostURL, $defaultURL;
	requireComponent("Textcube.Function.misc");
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)) {
		$data['myRecommand'] = 'show';
		$data['wigetKind'] = 1;
	}

	if(strcmp($data['myRecommand'],'hide') == 0)
		return $target;

	$id = DBN_get_bloggernews_id($mother);
	if(is_null($id)) {
		$mixsh = "<object classid='clsid:d27cdb6e-ae6d-11cf-96b8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0' width='349' height='89' align='middle'>
	<param name='allowScriptAccess' value='always'/>
	<param name='movie' value='http://www.mixsh.com/widget/mixup/loader.html?muid=92&guid=".$defaultURL."/".$mother."&rdate=[##_article_rep_date_##]&showhitcnt=1&platform=2'/>
	<param name='quality' value='high'/>
	<param name='wmode' value='window'/>
	<embed src='http://www.mixsh.com/widget/mixup/loader.html?muid=92&guid=".$defaultURL."/".$mother."&rdate=[##_article_rep_date_##]&showhitcnt=1&platform=2' quality='high' wmode='window' width='349' height='89' allowScriptAccess='always' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer'/>
</object>";
		misc::dress('bloggernews', $mixsh, $entryView); 
		return $target;
	}

	switch($data['wigetKind']) {
		case 1:
			$width = 400;
			$height = 80;
			$flash_url = "http://api.bloggernews.media.daum.net/static/recombox1.swf";
			break;
		case 2:
			$width = 400;
			$height = 58;
			$flash_url = "http://api.bloggernews.media.daum.net/static/recombox2.swf";
			break;
		case 3:
			$width = 67;
			$height = 80;
			$flash_url = "http://api.bloggernews.media.daum.net/static/recombox3.swf";
			break;
		default:
			break;
	}

	switch($data['wigetKind']) {
		case 1:
		case 2:
		case 3:
		$mixsh = "<object classid='clsid:d27cdb6e-ae6d-11cf-96b8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0' width='73' height='79' align='left' style='border-bottom: 1px solid #CFD4DA'>
	<param name='allowScriptAccess' value='always'/>
	<param name='movie' value='http://www.mixsh.com/widget/mixup/loader.html?muid=92&guid=".$defaultURL."/".$mother."&rdate=[##_article_rep_date_##]&showhitcnt=1&platform=2'/>
	<param name='quality' value='high'/>
	<param name='wmode' value='window'/>
	<embed src='http://www.mixsh.com/widget/mixup/loader.html?muid=92&guid=".$defaultURL."/".$mother."&rdate=[##_article_rep_date_##]&showhitcnt=1&platform=2' quality='high' wmode='window' width='73' height='79' allowScriptAccess='always' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer'/>
</object>";

			$wiget = $mixsh."<object height=\"{$height}\" align=\"left\" width=\"{$width}\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\">
<param value=\"always\" name=\"allowScriptAccess\"/>
<param value=\"{$flash_url}\" name=\"movie\"/>
<param value=\"nid={$id}\" name=\"flashvars\"/>
<param value=\"high\" name=\"quality\"/>
<param value=\"#ffffff\" name=\"bgcolor\"/>
<embed height=\"{$height}\" align=\"left\" width=\"{$width}\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" type=\"application/x-shockwave-flash\" allowscriptaccess=\"always\" bgcolor=\"#ffffff\" quality=\"high\" flashvars=\"nid={$id}\" src=\"{$flash_url}\" style=\"VISIBILITY: visible\" addthis_hidden=\"true\"/>
</object>";
			break;
		case 4:
			$wiget = "<div style=\"width:100%;text-align:center;\">  
<fieldset style=\"border:1px solid #a1b0db;text-align:left;width:312px;height:63px;padding:0;margin:0 auto;position:relative;\">   
<legend style=\"margin:0 0 0 10px;padding:0 3px;border:1px\">  
<a href=\"http://bloggernews.media.daum.net/\" onclick=\"window.open(this.href); return false;\" style=\"border: none;\"><img src=\"http://img-section.hanmail.net/blognews/common/bl_news.gif\" width=\"94\" height=\"13\" alt=\"Daum 블로거뉴스\" border=\"0\"></a></legend>  
<div style=\"font:12px 굴림;color:#31438f;letter-spacing:-1px;margin:11px 0 0 11px\">  
블로거뉴스에서 이 포스트를 추천해주세요.</div>  
<div style=\"text-decoration:none;margin:1px 0 0 12px\">  
<a href=\"http://bloggernews.media.daum.net/news/".$id." \" onclick=\"window.open(this.href); return false;\" style=\"font:10px tahoma;color:#929292;text-decoration:none;border: none;\">  
http://bloggernews.media.daum.net/news/".$id."</a></div>  
<div style=\"position:absolute;margin:-30px 0 0 246px\"><a href=\"http://bloggernews.media.daum.net/news/".$id."?rec=1\"  onclick=\"window.open(this.href); return false;\" style=\"border: none;\">  
<img src=\"http://img-section.hanmail.net/blognews/common/bl_recom.gif\" width=\"54\" height=\"30\" alt=\"추천하기\" style=\"border:none\"></a></div>  
</fieldset></div>";  
			break;
		default:
			$wiget = "";
			break;
	}

	misc::dress('bloggernews', $wiget, $entryView); 
	return $target;
	
}

function DaumBloggerNews_BestNews($target) {
	global $configVal;
	if (isset($target['preview']))
		return "Daum블로거뉴스의 베스트 기사 목록을 보여줍니다.";

	requireComponent('Textcube.Core');
	requireComponent('Needlworks.Cache.PageCache');
	$cache = new PageCache;
	$cache->name = 'DBN_BestNews';

	if($cache->load()) { //If successful loads
		if((time() - $cache->dbContents) < 3600)	// refresh time check
			return $cache->contents;
	}

	requireComponent("Textcube.Function.misc");
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['bestHeader'] = "<div id=\"DBN_bestnews\" class=\"recent module\">\n<h3>다음블로거뉴스 베스트</h3>";
		$data['bestFooter'] = "</div>";
		$data['bestLink'] = 'blink';
		$data['bestLink_length'] = 30;
	}

	$target = $data['bestHeader']. "<ol>". DBN_sidebar_view('http://bloggernews.media.daum.net/openapi/best_news.xml', ($data['bestLink'] == "blink"), $data['bestLink_length']). "</ol>". $data['bestFooter'];

	$cache->contents = $target;
	$cache->dbContents = Timestamp::getUNIXtime();
	$cache->update();
	unset($cache);

	return $target;
}

function DaumBloggerNews_MyNews($target) {
	global $configVal, $defaultURL, $database;
	global $view, $defaultURL;
	if (isset($target['preview']))
		return "내가 송고한 블로거뉴스 기사 목록을 보여줍니다.";

	requireComponent('Textcube.Core');
	requireComponent('Needlworks.Cache.PageCache');
	$cache = new PageCache;
	$cache->name = 'DBN_MyNews';

	if($cache->load()) { //If successful loads
		if((time() - $cache->dbContents) < 3600)	// refresh time check
			return $cache->contents;
	}
	requireComponent("Textcube.Function.misc");
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['myHeader'] = "<div id=\"DBN_mynews\" class=\"recent module\">\n<h3>나의 다음블로거뉴스</h3>";
		$data['myFooter'] = "</div>";
		$data['myLink'] = 'blink';
		$data['myLink_length'] = 30;
	}

	$target = $data['myHeader']. "<ol>". DBN_sidebar_view('http://bloggernews.media.daum.net/openapi/my_news.xml?blogurl='. rawurlencode($defaultURL), ($data['myLink'] == "blink"), $data['myLink_length']). "</ol>". $data['myFooter'];

	$cache->contents = $target;
	$cache->dbContents = Timestamp::getUNIXtime();
	$cache->update();
	unset($cache);

	return $target;
}

function DaumBloggerNews_Banner($target){
	global $configVal, $defaultURL;
	global $view, $defaultURL;
	if (isset($target['preview']))
		return "다음 블로그 공식 배너.";

	requireComponent("Textcube.Function.misc");
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['bannerHeader'] = "<p style=\"text-align:center; margin: 0; padding: 0;\">";
		$data['bannerFooter'] = "</p>";
	}

	$target = $data['bannerHeader']. "<a href=\"http://bloggernews.media.daum.net\" onclick=\"window.open(this.href); return false;\"><img src=\"http://img-section.hanmail.net/blognews/banner/big.gif\" alt=\"Daum 블로거뉴스\" width=\"162\" height=\"52\" /></a>". $data['bannerFooter'];

	return $target;
}

?>